import numpy as np
import struct

def savePGM( Img, filename ) :
	# define the width  (columns) and height (rows) of your image
	height, width = Img.shape

	# open file for writing 
	try:
		fout=open(filename, 'wb')
	except:
		print( "No puedo abrir el archivo", filename )
		return

	# define PGM Header
	pgmHeader = 'P5' + '\n' + str(width) + ' ' + str(height) + '\n' + str(255) +  '\n'

	pgmHeader_byte = bytearray(pgmHeader,'utf-8')

	# write the header to the file
	fout.write(pgmHeader_byte)

	# write the data to the file 
	j = 0
	while j < height :
		fout.write( bytearray(Img[j,:]) )

		j += 1

	fout.close()

def readPGM( filename  ) :
# Read an image in P5 PGM format
	try :
		filep = open( filename, 'rb' )
	except:
		print( "No puedo abrir el archivo", filename )

	line = filep.readline()
	if line[0] != 'P' and line[1] != '5' :
		print( "No esta en formato PGM" )

	while 1:		 
		line = filep.readline()
		if line[0] != '#' :
			break

	d = line.split( )
	
	rows = int( d[1] )
	cols = int( d[0] )
	print( rows, cols )

	while 1:		 
		line = filep.readline()
		if line[0] != '#' :
			break
	g = int( line )

	if g != 255 :
		print( "La imagen tiene más de 256 tonos de gris" )
		return

	print( g )

	Img = np.zeros( (rows,cols), dtype=np.uint8 )

	i = 0
	while i < rows :
		line = filep.read( cols )
		j = 0
		while j < cols :
			Img[i,:] = struct.unpack( 'B'*cols, line  )
			j += 1

		i += 1
	return Img
